#Version 0.6.2

#We import random for the dice roller. While not truly random, it's close enough for our purposes here. Math is used for rounding.
import random
import math

#X is the poorly named object that the final output is stored in.
x = {}

#roller is the dice roller I created. It takes a number of sides, number of die rolled, whether or not the roll is for stats, and whether or not it has a bonus.
def roller(sides, num=1, statroll = False, bonus = 0):
    #Output is initialized as a list by default
    output = []
    #If the roll is only for a single die, it runs this bit of code instead
    if (num == 1):
        #Output is changed to a single integer, equal to a random number between 0 and the number of sides, plus one. The bonus is added to the output, and returned.
        output = random.randrange(0,sides) + 1
        return output + bonus
    #If the roll is for multiple dice, it loops through the number of die being rolled generates a random number between zero and the number of sides plus one and appends it to output
    else:
        for i in range(num):
            output.append(random.randrange(0,sides)+1)
        #if the roll is for stats, it sorts the output and pops the lowest number
        if(statroll):
            output.sort()
            output.pop(0)
        #output is then summed up and returned with the bonus added.
        return sum(output) + bonus

#This function is an absolute nightmare. I created it as a way of automatically sorting through and selecting values from dictionaries at random. It is as bloated as it is due to the weird and inconsistent structuring I have for my data.
#It takes four values. The first is a dictionary, the second is a value for multiple die being rolled, the third is a value for bonuses to rolls, and the fourth is whether or not it should loop through the entire dictionary, true by default.
def dictpicker2(r, n=1, b=0, loop = True):
    #Most of the dictionaries use integers as keys for the rolls, but there are some that use strings because it makes more sense. This checks to see if the last item in a dictionary is a string, and if it supposed to loop through the entire dictionary
    #This is mostly for things like family and origin where you want to generate something from every item in those dictionaries
    if (type(list(r)[-1]) is str and loop == True):
        #l is created as a blank dictionary to write values to
        l = {}
        #We loop through every key in r, running dictpicker2 on that specific entry in r. This breaks if the value is anything other than a dictionary, need to revise this, but it doesn't break anything CURRENTLY
        for i in r:
            l[i] = dictpicker2(r[i])
        return l
    #If the looping is disabled, it picks a single random keyy in the r dictinary and runs dictpicker on that, returning the value
    elif(type(list(r)[-1]) is str and loop == False):
        l = list(r.keys())[random.randrange(0,len(list(r.keys())))]
        y = {}
        y[l] = dictpicker2(r[l])
        return y

    #if r's keys aren't strings, it creates a dice roll based on the last number in the dictionary. if a N is supplied, it divides the key by that, and then rolls that number of die. For example, supplying 18 with an n of three would roll 3d6
    num = roller(list(r)[-1]/n, n, False, b)
    #if the rolled number is greater than the last key, it checks to see if the last key is a dictionary. If it is, it runs dictpicker on that dictionary and returns that value instead.
    #if it isn't a dictionary, it returns the last key directly since it rolled over. This is only really possible with modifiers.
    if num > list(r)[-1]:
        if(type(r[list(r)[-1]]) is dict):
            return dictpicker2(r[list(r)[-1]])
        else:
            return r[list(r)[-1]]
    #otherwise, it loops through the keys (as k) in r. If the rolled number is greater than the key, it skips the block and goes to the next key.
    #if it's less than the key, it runs the block below, which is similar to the above. If the type it lands  on is a dictionary, it returns the dictpicker value of that dictionary
    #if it's not a dictionary, it returns the value of that entry
    for k in r:
        if num <= k:
            if(type(r[k]) is dict):
                return dictpicker2(r[k])
            else:
                return r[k]

#The tables are structured in a fairly nonstandard way (by which I mean I haven't seen it before in my many minutes of python programming)
#If a value is meant to be rolled, the key equates to a number. The dictionary rolls a number between one and the value of the last key, so keys are ordered in ascending value
#By carefully selecting the keys, we can directly influence the odds of any specific roll.
#Because I suck at structuring data consistently, some dictionaries include strings for keys, some include additional dictionaries as values, some are top level values and some are nested
#this lack of consistency is why the dictpicker function is as needlessly specific as it is. I will revise this eventually.

#The supplemental table is meant to supply supplemental values, such as race, alignment, occupation, cause of death (if they died), and other miscellaneous values. 
#Currently, the entire table is looped through when generating it, and irrelevant values are popped. This is easier than selectively pulling tables, in my opinion, though likely less efficient.

Supplemental = {
    "Alignment":{
        5:"Chaotic Evil",
        10:"Chaotic Neutral",
        18:"Lawful Evil",
        26:"Neutral Evil",
        50:"Neutral",
        64:"Neutral Good",
        72:"Lawful Neutral",
        80:"Lawful Good",
        85:"Chaotic Good",
        90:"Chaotic Neutral"
    },
    "Occupation":{
        5:"Academic",
        10:"Adventurer",
        11:"Aristocrat",
        26:"Artisan or guild member",
        31:"Criminal",
        36:"Entertainer",
        38:"Exile, hermit, or refugee",
        43:"Explorer or wanderer",
        55:"Farmer or herder",
        60:"Hunter or trapper",
        75:"Laborer",
        80:"Merchant",
        85:"Politician or beuraucrat",
        90:"Priest",
        95:"Sailor",
        100:"Soldier"
    },
    "Class":{
        7:"Barbarian",
        14:"Bard",
        29:"Cleric",
        36:"Druid",
        52:"Fighter",
        58:"Monk",
        64:"Paladin",
        70:"Ranger",
        84:"Rogue",
        89:"Sorceror",
        94:"Warlock",
        100:"Wizard"
    },
    "Race":{
        40:"Human",
        50:"Dwarf",
        60:"Elf",
        70:"Halfling",
        75:"Dragonborn",
        80:"Gnome",
        85:"Half-elf",
        90:"Half-orc",
        95:"Tiefling",
        100:{
            10:"Exotic Race"
        }
    },
    "Relationship":{
        4:"Hostile",
        10:"Friendly",
        12:"Indifferent"
    },
    "Status":{
        3:"Dead",
        5:"Missing or unknown",
        8:"Alive but doing poorly due to injury, financial trouble, or relationship difficulties",
        12:"Alive and well",
        15:"Alive and quite successful",
        17:"Alive and infamous",
        18:"Alive and famous"
    },
    "Cause of Death":{
        1:"Unknown",
        2:"Murdered",
        3:"Killed in battle",
        4:"Accident related to class or occupation",
        5:"Accident unrelated to class or occupation",
        7:"Nautral causes, such as disease or old age",
        8:"Apparent suicide",
        9:"Torn apart by an animal or a natural disaster",
        10:"Consumed by a monster",
        11:"Executed for a crime or tortured to death",
        12:"Bizarre event, such as being hit by a meteorite, struck down by an angry god, or killed by a hatching Slaad egg"
    },
}

#A simple value for returning a bunch of supplementals. If a character is not dead, it removes the "Cause of death" value, and if their occupation is not "Adventurer", it pops tvishe "Class" value. It then returns all the rolled values.
def useSupplementals():
    y = dictpicker2(Supplemental)
    if y["Status"] != "Dead":
        y.pop("Cause of Death")
    if y["Occupation"] != "Adventurer":
        y.pop("Class")
    return y

#don't look at this :(
def renderAdventurerF():
    return "You befriend an adventurer of some renown. Perhaps in the future this life event will have more to it."

#this function is ridiculously sloppy, but I didn't have any better ideas for formatting it when I made it. It creates a series of values for an adventurer who is, for some reason or another, hostile toward the player character.
def renderAdventurerH():
    #Intializes a dictionary with the first value being a description of the event that occurred, and a call to the player to work out additional details with their DM
    z = {"Event:":"You have made an enemy of an adventurer of some repute. Work with your DM to determine the identity of this adventurer, and the danger they may pose to you."}

    #We then initialize a second dictionary with the output of the ENTIRE supplemental table.
    a = dictpicker2(Supplemental)
    #We remove the cause of death and status values, as those are irrelevant to this roll, as well as changing the "Occupation" and "Relationship" to adventurer and hostile respectively.
    a.pop("Cause of Death")
    a.pop("Status")
    a["Occupation"] = "Adventurer"
    a["Relationship"] = "Hostile"
    #if the value is 0 it's the players fault that the  adventurer is angry, and if it's 1, it's an outside influence. 
    if(random.randrange(0,2)):
        a["Fault"] = "This adventurer is hostile through no fault of your own. Work with your DM to determine the exact details."
    else:
        a["Fault"] = "You have done something to this adventurer that made them hostile to you. Work with your DM to determine the exact details."
    return {**z, **a}

#don't look at this either :(
def renderImportant():
    return "You have a chance meeting with a person of some import. Perhaps in the future this life event will have more to it."


#VERY sloppy table, this is the first one that I created, and it shows. 
#Origin encompasses large parts of the character's origin, their parents and family
Origin ={
    "Parents":{ 
        "Known":{ 
            
            90:True,
            100:False,
        },
        "Gender":{ 
            
            10:"Nonbinary",
            55:"Female",
            100:"Male"
        },
        "Fate":{ 
            1:"Your parent died",
            2:"Your parent was imprisoned, enslaved, or otherwise taken away.",
            3:"Your parent abandoned you.",
            4:"Your parent disappeared to an unknown fate."
        }
    },
    "Siblings":{
        "Known":{ 
            97:True,
            100:False
        },
        "Gender":{
            10:"Nonbinary",
            55:"Female",
            100:"Male"
        },
        "Age":{
            1:"Twins/Triplets/Quadruplets",
            6:"Older",
            11:"Younger"
        }
    },
    "Birthplace":{ 
        50:"Home",
        55:"Home of a family friend",
        63:"Home of a healer or midwife",
        65:"Carriage, cart, or wagon",
        68:"Barn, shed, or other outbuilding",
        70:"Cave",
        72:"Field",
        74:"Forest",
        77:"Temple",
        78:"Battlefield",
        80:"Alley or street",
        82:"Brothel, tavern, or inn",
        84:"Castle, keep, tower, or palace",
        85:"Sewer or rubbish heap",
        88:"Among people of a different race",
        91:"On board a boat or ship",
        93:"In prison or in the headquarters of a secret society",
        95:"In a sage's laboratory",
        96:"In the feywild",
        97:"In the Shadowfell",
        98:"On the Astral or Ethereal planes",
        99:"On an inner plane of your choice",
        100:"On an outer plane of your choice"
    },
    "Family":{ 
        1:"None",
        2:"Institution, such as an asylum",
        3:"Temple",
        5:"Orphanage",
        7:"Guardian",
        15:"Paternal or maternal aunt, uncle, or both; or extended family such as a tribe or clan",
        25:"Paternal or maternal grandparent(s)",
        35:"Adpotive family (same or different race)",
        60:"Single parent of your choice",
        100:"Birth Parents"
    },
    "Lifestyle":{
        3:"Wretched",
        5:"Squalid",
        8:"Poor",
        12:"Modest",
        15:"Comfortable",
        17:"Wealthy",
        18:"Aristocratic"
    },
    "Home":{ 
        0:"On the streets",
        20:"Rundown Shack",
        30:"No permanent residence, you moved around a lot",
        40:"Encampment or village in the wilderness",
        50:"Apartment in a rundown neighborhood",
        70:"Small house",
        90:"Large house",
        110:"Mansion",
        120:"Palace or castle",
    },
    "Memories":{ 
        3:"I am still haunted by my childhood, when I was treated badly by my peers.",
        5:"I spent most of my childhood alone, with no close friends.",
        8:"Others saw me as being different or  strange, and so I had few companions.",
        12:"I had a few close friends and lived an ordinary childhood.",
        15:"I had several friends, and my childhood was generally a happy one.",
        17:"I always found it easy to make friends, and I loved being around people.",
        18:"Everyone knew who I was, and I had friends everywehre I went",
    }
}
Background = {
    "Acolyte":{
        1:"I ran away from home at an early age and found refuge in a temple.",
        2:"My family gave me to a temple, since they were unable or unwilling to care for me.",
        3:"I grew up in a household with strong religious convictions. Entering the service of one or more gods seemed natural.",
        4:"An impassioned sermon struck a chord deep in my soul and moved me to serve the faith.",
        5:"I followed a childhood friend, a respected acquaintance, or someone I loved into religious service.",
        6:"After encountering a true servant of the gods, I was so inspired that I immediately entered the service of a religious group."
    },
    "Charlatan":{
        1:"I was left to my own devices, and my knack for manipulating others helped me survive.",
        2:"I learned early on that people are gullible and easy to exploit.",
        3:"I often got in trouble, but I managed to talk my way out of it every time.",
        4:"I took up with a confidence artist, from whom I learned my craft.",
        5:"After a charlatan fleeced my family, I decided to learn the trade so I would never be fooled by such deception again.",
        6:"I was poor or I feared becoming poor, so I learned the tricks I needed to keep myself out of poverty."
    },
    "Criminal":{
        1:"I resented authority in my younger days and saw a life of crime as the best way to fight against tyranny and oppression.",
        2:"Necessity forced me to take up the life, since it was the only way I could survive.",
        3:"I fell in with a gang of reprobates and ne'er-do-wells, and I learned my specialty from them.",
        4:"A parent or relative taught me my criminal specialty to prepare me for the family business.",
        5:"I left home and found a place in a thieves' guild or some other criminal organization.",
        6:"I was always bored, so I turned to crime to pass the time and discovered I was quite good at it."
    },
    "Entertainer":{
        1:"Members of my family made ends meet by performing, so it was fitting for me to follow their example.",
        2:"I always had a keen insight into other people, enough so that I could make them laugh or cry with my stories or songs.",
        3:"I ran away from home to follow a minstrel troupe.",
        4:"I saw a bard perform once, and I knew from that moment on what I was born to do.",
        5:"I earned coin by performing on street corners and eventually made a name for myself.",
        6:"A traveling entertainer took me in and taught me the trade."
    },
    "Folk Hero":{
        1:"I learned what was right and wrong from my family.",
        2:"I was always enamored by tales of heroes and wished I could be something more than ordinary.",
        3:"I hated my mundane life, so when it was time for someone to step up and do the right thing, I took my chance.",
        4:"A parent or one of my relatives was an adventurer, and I was inspired by that courage.",
        5:"A mad old hermit spoke a prophecy when I was born, saying that I would accomplish great things.",
        6:"I have always stood up for those who are weaker than I am."
    },
    "Guild Artisan":{
        1:"I was apprenticed to a master who taught me the guild's business.",
        2:"I helped a guild artisan keep a secret or complete a task, and in return I was taken on as an apprentice.",
        3:"One of my family members who belonged to the guild made a place for me.",
        4:"I was always good with my hands, so I took the opportunity to learn a trade.",
        5:"I wanted to get away from my home situation and start a new life.",
        6:"I learned the essentials of my craft from a mentor but had to join the guild to finish my trainer."
    },
    "Hermit":{
        1:"My enemies ruined my reputation, and I fled to the wilds to avoid further disparagement.",
        2:"I am comfortable with being isolated, as I seek inner peace.",
        3:"I never liked the people I called my friends, so it was easy for me to strike out on my own.",
        4:"I felt compelled to forsake my past, but did so with great reluctance, and sometimes I regret making that decision.",
        5:"I lost everything - my home, my family, my friends. Going it alone was all I could do.",
        6:"Society's decadence disgusted me, so I decided to leave it all behind."
    },
    "Noble":{
        1:"I come from an old and storied family, and it fell to me to preserve the family name.",
        2:"My family has been disgraced, and I intend to clear our name.",
        3:"My family recently came by its title, and that elevation thrust us into a new and strange world.",
        4:"My family has a title, but none of my ancestors have distinguished themselves since we gained it.",
        5:"My family is filled with remarkable people. I hope to live up to their example.",
        6:"I hope to increase my family's power and influence."
    },
    "Outlander":{
        1:"I spent a lot of time in the wilderness as a youngster, and I came to love that way of life.",
        2:"From a young age, I couldn't abide the stink of the cities and preferred to spend my time in nature.",
        3:"I came to understand the darkness that lurks in the wilds, and I vowed to combat it.",
        4:"My people lived on the edges of civilization, and I learned the methods of survival from my family.",
        5:"After a tragedy I retreated to the wilderness, leaving my old life behind.",
        6:"My family moved away from civilization, and I learned to adapt to my new environment."
    },
    "Sage":{
        1:"I was naturally curious, so I packed up and went to a university to learn more about the world.",
        2:"My mentor's teachings opened my mind to new possibilities in that field of study.",
        3:"I was always an avid reader, and I learned much about my favorite topic on my own.",
        4:"I discovered an old library and pored over the texts I found there. That experience awakened a hunger for more knowledge.",
        5:"I impressed a wizard who told me I was squandering my talents and should seek out an education to take advantage of my gifts.",
        6:"One of my parents or a relative gave me a basic education hat whetted my appetite, and I left home to build on what I had learned."
    },
    "Sailor":{
        1:"I was press-ganged by pirates and forced to serve on their ship until I finally escaped.",
        2:"I wanted to see the world, so I signed on as a deckhand for a merchant ship.",
        3:"One of my relatives was a sailor who took me to sea.",
        4:"I needed to escape my community quickly, so I stowed away on a ship. When the crew found me, I was forced to work for my passage.",
        5:"Reavers attacked my community, so I found refuge on a ship until I could seek vengeance.",
        6:"I had few prospects where I was living, so I left to find my fortune elsewhere."
    },
    "Soldier":{
        1:"I joined the militia to help protect my community from monsters.",
        2:"A relative of mine was a soldier, and I wanted to carry on the family tradition.",
        3:"The local lord forced me to enlist in the army.",
        4:"War ravaged my homeland while I was growing up. Fighting was the only life I ever knew.",
        5:"I wanted fame and fortune, so I joined a mercenary company, selling my sword to the highest bidder.",
        6:"Invaders attacked my homeland. It was my duty to take up arms in defense of my people."
    },
    "Urchin":{
        1:"Wanderlust caused me to leave my family to see the world. I look after myself.",
        2:"I ran away from a bad situation at home and made my own way in the world.",
        3:"Monsters wiped out my village, and I was the sole survivor. I had to find a way to survive.",
        4:"A notorious htief looked after me and other orphans, and we spied and stole to earn our keep.",
        5:"One day I woke up on the streets, alone and hungry, with no memory of my early childhood.",
        6:"My parents died, leaving no one to look after me. I raised myself."
    }
}
LifeEvents = {
    10:{ 
        2:"A family member or a close friend died. Roll on the Cause of death supplamental table to find out how.",
        3:"A friendship ended bitterly, and the other person is now hostile to you. The cause might have been a misunderstanding or something you or the former friend did.",
        4:"You lost all your possessions in a disaster, and you had to rebuild your life.",
        5:"You were imprisoned for a crime you didn't commit and spent 1d6 years at hard laborm in jail, or shackled to an oar in a slave galley.",
        6:"War ravaged your home community, reducing everything to rubble and ruin. In the aftermath, you either helped your town rebuild or moved somewhere else.",
        7:"A lover disappeared without a trace. You have been looking for that person ever since.",
        8:"A terrible blight in your home community caused crops to fail, and many starved. You lost a sibling or some other family member.",
        9:"You did something that brought terrible shame to you in the eyes of your family. You might have been involved in a scandal, dabbled in dark magic, or offended someone important. The attitude of your family members toward you becomes indifferent at best, though they might eventually forgive you.",
        10:"For a reason you were never told, you were exiled from your community. You then either wandered in the wilderness for a time, or promptly found a new place to live.",
        11:"A romantic relationship ended. Roll a d6. An odd number means it ended with bad feelings, while an even number means it ended amicably",
        12:"A current or prospective romantic partner died. Roll on the cause of death supplemental table to find out how. If the result is murder, roll a d12. On a 1, you were responsible, whether directly or indirectly."
    }, 
    20:{ 
        1:"A friendly wizard gave you a spell scroll containing one cantrip (of the DM's choice)",
        2:"You saved the life of a commoner, who now owes you a life debt. This individual accompanies you on your travels and performs mundane tasks for you, but will leave if neglected, abused, or imperiled. Determine details about this character by using the supplemental tables and working with your DM.",
        3:"You found a riding horse.",
        4:"You found some money. You have 1d20GP in addition to your starting funds.",
        5:"A relative bequeathed a simple weapon of your choice.",
        6:"You found something interesting. You gain one additional trinket.",
        7:"You once performed a service for a local temple. The next time you visit the temple, you can receive healing up to your hit point maximum.",
        8:"A friendly alchemist has gifted you with a potion of healing or a flask of acid, as you choose.",
        9:"You found a treasure map.",
        10:"A distant relative left you a stipend that allows you to live at the comforable lifestyle for 1d20 years. If you choose to live at a higher lifestyle, you reduce the price of the lifestyle by 2gp during that time period.",
    },
    30:"You fell in love or got married. If you get this result more than once, you can choose to have a child instead. Work with your DM to determine the identity of your love interest.",
    40:renderAdventurerF, 
    50:renderAdventurerH, 
    70:"You spent time working in a job related to your background. You start your adventure with a little extra GP",
    75:renderImportant,
    80:{ 
        10:"You nearly died. You have nasty scars on your body, and you are missing an ear, 1d3 fingers, or 1d4 toes.",
        20:"You suffered a grievous injury. Although the wound healed, it still pains you from time to time.",
        30:"You were wounded, but in time you fully recovered.",
        40:"You contracted a disease while exploring a filthy warren. You recovered from the disease, but you have a persistent cough, pockmarks on your skin, or prematurely gray hair.",
        50:"You were poisoned by a trap or a monster. You recovered, but you'll never forget the feeling of venom coursing through your veins.",
        60:"You lost something of sentimental value to you during your adventure. Remove one trinket from your possessions.",
        70:"You were terribly frightened by something you encountered and ran away, abandoning your companions to their fate.",
        80:"You learned a great deal during your adventure. You begin your campaign with a point of inspiration.",
        90:"You found some treasure on your adventure. You have 2d6GP from your share of it.",
        99:"You found a considerable amount of treasure on your adventure. You have 1d20 + 50 left from your share of it.",
        100:"You come across a common magic item (of the DM's choice.)"
    },
    85:{ 
        5:"You were ensorcelled by a fey and enslaved for 1d6 years before you escaped.",
        10:"You saw a demon and ran away before it could do anything to you.",
        15:"A devil tempted you. Make a DC10 wisdom saving throw. On a failed save, your alignment shifts one step toward evil, and you start the game with an aditional 1d20 + 50gp",
        20:"You woke up one morning miles from your home, with no idea how you got there.",
        30:"You visited a holy site and felt the presence of the divine there.",
        40:"You witnessed a falling red star, a face appearing in the frost, or some other bizarre happening. You are certain that it was an omen of some sort.",
        50:"You escaped certain death and believe it was the intervention of a god that saved you.",
        60:"You witnessed a minor miracle.",
        70:"You explored an empty house and found it to be haunted.",
        75:"You were briefly possessed. Roll a d6 to determine what type of creature possessed you: 1, celestial; 2, devil; 3, demon; 4, fey; 5, elemental; 6, undead",
        80:"You saw a ghost.",
        85:"You saw a ghoul feeding on a corpse.",
        90:"A celestial or fiend visited you in your dreams to give a warning of dangers to come.",
        95:"You briefly visited the feywild or the shadowfell",
        100:"You saw a portal that you believe leads to another plane of existence."
    }, 
    90:{ 
        1:"You were knocked out and left for dead. You woke up hours later with no recollection of the battle.",
        3:"You were badly injured in the fight, and you still bear the awful scars of those wounds.",
        4:"You ran away from the battle to save your life, but you still feel shame for your cowardice.",
        7:"You suffered only minor injuries, and the wounds all healed without leaving scars.",
        9:"You survived the battle, but you suffer from terrible nightmares in which you relive the experience.",
        11:"You escaped the battle unscathed, though many of your friends were injured or lost.",
        12:"You caried yourself well in battle and are remembered as a hero. You may have recieved a medal for your bravery."
    }, 
    95:{
        "Crime":{
            1:"Murder",
            2:"Theft",
            3:"Burglary",
            4:"Assault",
            5:"Smuggling",
            6:"Kidnapping",
            7:"Extortion",
            8:"Counterfeiting"
        },
        "Punishment":{
            3:"You did not commit the crime and were exonerated after being accused.",
            6:"You committed the crime or helped do so, but nonetheless the authorities found you not guilty.",
            8:"You were nearly caught in the act. You had to flee and are wanted in the community where the crime occurred.",
            12:"You were caught in convicted. You spent time in jail, chained to an oar, or performing hard labor. You served a sentence of 1d4 years or succeeded in escaping after that much time."
        }
    }, 
    99:{ 
        1:"You were charmed or frightened by a spell cast on you.",
        2:"You were injured by the effect of a spell.",
        3:"You witnessed a powerful spell being cast by a cleric, a druid, a sorceror, a warlock, or a wizard.",
        4:"You drank a potion (of the DM's choice).",
        5:"You found a spell scroll (of the DM's choice), and succeeded in casting the spell it contained.",
        6:"You were affected by teleportation magic.",
        7:"You turned invisible for a time.",
        8:"You identified an illusion for what it was.",
        9:"You saw a creature being conjured by magic.",
        10:"Your fortune was read by a diviner. Roll twice on the life events table, but don't apply the results. Instead, the DM picks one event as a portent of your future, which may or may not happen."
    }, 
    100:{ 
        1:"You were turned into a toad and remained in that form for 1d4 weeks.",
        2:"You were petrified and remained a stone statue for a time until someone freed you.",
        3:"You were enslaved by a hag, a satyr, or some other being and lived in that creature's thrall for 1d6 years.",
        4:"A dragon held you as a prisoner for 1d4 months until adventurers killed it.",
        5:"You were taken captive by a race of evil humanoids. You lived as a slave in the Underdark until you escaped.",
        6:"You served a powerful adventurer as a hireling. You have only recently left that service. Use the supplemental tables and work with your DM to determine the basic details about your former employer.",
        7:"You went insane for 1d6 years years and recently regained your sanity. A tic or some other bit of odd behavior may linger.",
        8:"A lover of yours was secretly a silver dragon.",
        9:"You were captured by a cult and nearly sacrificed on an altar to the foul being the cultists served. You escaped, but you fear they will find you.",
        10:"You met a demigod, an archdevil, an archfey, a demon lord, or a titan, and you lived to tell the tale.",
        11:"You were swallowed by a giant fish and spent a month in its gullet before you escaped.",
        12:"A powerful being granted you a wish, but you squandered it on something frivolous."
    } 
}

def ParentGen(num = 2, detail = 3):
    x["Parents"] = {}
    for i in range(num):
        y = x["Parents"][i+1] = dictpicker2(Origin["Parents"])
        if y["Known"]:
            y.pop("Fate")
    
    x["Birthplace"] = dictpicker2(Origin["Birthplace"])
    x["Family"] = dictpicker2(Origin["Family"])
    x["Lifestyle"] = dictpicker2(Origin["Lifestyle"],3)
    n = 0
    lstyle = x["Lifestyle"]
    if(lstyle == "Wretched"):
        n = -40
    elif(lstyle == "Squalid"):
        n = -20
    elif(lstyle == "Poor"):
        n = -10
    elif(lstyle == "Comfortable"):
        n = 10
    elif(lstyle == "Wealthy"):
        n = 20
    elif(lstyle == "Aristocratic"):
        n = 40
    x["Home"] = dictpicker2(Origin["Home"], 1, n)
    x["Memories"] = dictpicker2(Origin["Memories"], 3, math.floor(x["Stats"]["Cha"]/2 - 5))

def SiblingGen(detail = 3):
    y = roller(10)
    siblings = 0
    if(y == 3 or y==4):
        siblings = roller(3)
    elif(y == 5 or y== 6):
        siblings = roller(4) + 1
    elif(y == 7 or y == 8):
        siblings = roller(6)+2
    elif(y == 9 or y==10):
        siblings = roller(8) + 3
    if(siblings):
        x["Siblings"] = {}
        for i in range(siblings):
            y = x["Siblings"][i + 1] = dictpicker2(Origin["Siblings"])
            y["DETAILS"] = useSupplementals()
            y["DETAILS"].pop("Race")

def lifeEventsGen(age = 25):
    x["Life Events"] = {}
    levents = 1
    if (age > 20 and age <31):
        levents = roller(4)
    elif(age > 30 and age <41):
        levents = roller(6)
    elif(age > 40 and age < 51):
        levents = roller(8)
    elif(age >50 and age < 61):
        levents = roller(10)
    elif(age > 60):
        levents = roller(10)
    for i in range(levents):
        le = dictpicker2(LifeEvents)
        if callable(le):
            x["Life Events"][i+1] = le()
        else:
            x["Life Events"][i+1] = le

def charCreator():
    x["Stats"] = {}
    s = ["Str","Dex","Con","Int","Wis","Cha"]
    for i in s:
        x["Stats"][i] = roller(6,4,True)
    ParentGen()
    SiblingGen()
    x["Background"] = dictpicker2(Background,1,0,False)
    
    lifeEventsGen()
    print(x)
    for i in x:
        if type(x[i]) is dict:
            print(i + ":")
            for j in x[i]:
                print(j, end=": ")
                print(x[i][j])
        else:
            print(i, end=": ")
            print(x[i])
        print("\n")

charCreator()